# encoding: utf-8
#
# Copyright 2016 Game Server Services, Inc. or its affiliates. All Rights
# Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# or in the "license" file accompanying this file. This file is distributed
# on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
# express or implied. See the License for the specific language governing
# permissions and limitations under the License.


class Gold(object):

    def __init__(self, params=None):
        if params is None:
            self.__gold_id = None
            self.__owner_id = None
            self.__name = None
            self.__description = None
            self.__service_class = None
            self.__balance_max = None
            self.__reset_type = None
            self.__reset_day_of_month = None
            self.__reset_day_of_week = None
            self.__reset_hour = None
            self.__latest_gain_max = None
            self.__notification_url = None
            self.__create_wallet_trigger_script = None
            self.__create_wallet_done_trigger_script = None
            self.__deposit_into_wallet_trigger_script = None
            self.__deposit_into_wallet_done_trigger_script = None
            self.__withdraw_from_wallet_trigger_script = None
            self.__withdraw_from_wallet_done_trigger_script = None
            self.__create_at = None
            self.__update_at = None
        else:
            self.set_gold_id(params['goldId'] if 'goldId' in params.keys() else None)
            self.set_owner_id(params['ownerId'] if 'ownerId' in params.keys() else None)
            self.set_name(params['name'] if 'name' in params.keys() else None)
            self.set_description(params['description'] if 'description' in params.keys() else None)
            self.set_service_class(params['serviceClass'] if 'serviceClass' in params.keys() else None)
            self.set_balance_max(params['balanceMax'] if 'balanceMax' in params.keys() else None)
            self.set_reset_type(params['resetType'] if 'resetType' in params.keys() else None)
            self.set_reset_day_of_month(params['resetDayOfMonth'] if 'resetDayOfMonth' in params.keys() else None)
            self.set_reset_day_of_week(params['resetDayOfWeek'] if 'resetDayOfWeek' in params.keys() else None)
            self.set_reset_hour(params['resetHour'] if 'resetHour' in params.keys() else None)
            self.set_latest_gain_max(params['latestGainMax'] if 'latestGainMax' in params.keys() else None)
            self.set_notification_url(params['notificationUrl'] if 'notificationUrl' in params.keys() else None)
            self.set_create_wallet_trigger_script(params['createWalletTriggerScript'] if 'createWalletTriggerScript' in params.keys() else None)
            self.set_create_wallet_done_trigger_script(params['createWalletDoneTriggerScript'] if 'createWalletDoneTriggerScript' in params.keys() else None)
            self.set_deposit_into_wallet_trigger_script(params['depositIntoWalletTriggerScript'] if 'depositIntoWalletTriggerScript' in params.keys() else None)
            self.set_deposit_into_wallet_done_trigger_script(params['depositIntoWalletDoneTriggerScript'] if 'depositIntoWalletDoneTriggerScript' in params.keys() else None)
            self.set_withdraw_from_wallet_trigger_script(params['withdrawFromWalletTriggerScript'] if 'withdrawFromWalletTriggerScript' in params.keys() else None)
            self.set_withdraw_from_wallet_done_trigger_script(params['withdrawFromWalletDoneTriggerScript'] if 'withdrawFromWalletDoneTriggerScript' in params.keys() else None)
            self.set_create_at(params['createAt'] if 'createAt' in params.keys() else None)
            self.set_update_at(params['updateAt'] if 'updateAt' in params.keys() else None)

    def get_gold_id(self):
        """
        ゴールドGRNを取得
        :return: ゴールドGRN
        :rtype: unicode
        """
        return self.__gold_id

    def set_gold_id(self, gold_id):
        """
        ゴールドGRNを設定
        :param gold_id: ゴールドGRN
        :type gold_id: unicode
        """
        self.__gold_id = gold_id

    def get_owner_id(self):
        """
        オーナーIDを取得
        :return: オーナーID
        :rtype: unicode
        """
        return self.__owner_id

    def set_owner_id(self, owner_id):
        """
        オーナーIDを設定
        :param owner_id: オーナーID
        :type owner_id: unicode
        """
        self.__owner_id = owner_id

    def get_name(self):
        """
        ゴールド名を取得
        :return: ゴールド名
        :rtype: unicode
        """
        return self.__name

    def set_name(self, name):
        """
        ゴールド名を設定
        :param name: ゴールド名
        :type name: unicode
        """
        self.__name = name

    def get_description(self):
        """
        説明文を取得
        :return: 説明文
        :rtype: unicode
        """
        return self.__description

    def set_description(self, description):
        """
        説明文を設定
        :param description: 説明文
        :type description: unicode
        """
        self.__description = description

    def get_service_class(self):
        """
        サービスクラスを取得
        :return: サービスクラス
        :rtype: unicode
        """
        return self.__service_class

    def set_service_class(self, service_class):
        """
        サービスクラスを設定
        :param service_class: サービスクラス
        :type service_class: unicode
        """
        self.__service_class = service_class

    def get_balance_max(self):
        """
        各ウォレットの残高の最大値を取得
        :return: 各ウォレットの残高の最大値
        :rtype: long
        """
        return self.__balance_max

    def set_balance_max(self, balance_max):
        """
        各ウォレットの残高の最大値を設定
        :param balance_max: 各ウォレットの残高の最大値
        :type balance_max: long
        """
        self.__balance_max = balance_max

    def get_reset_type(self):
        """
        取得量の期間制限のタイプを取得
        :return: 取得量の期間制限のタイプ
        :rtype: unicode
        """
        return self.__reset_type

    def set_reset_type(self, reset_type):
        """
        取得量の期間制限のタイプを設定
        :param reset_type: 取得量の期間制限のタイプ
        :type reset_type: unicode
        """
        self.__reset_type = reset_type

    def get_reset_day_of_month(self):
        """
        期間内の取得量をリセットする日にちを取得
        :return: 期間内の取得量をリセットする日にち
        :rtype: int
        """
        return self.__reset_day_of_month

    def set_reset_day_of_month(self, reset_day_of_month):
        """
        期間内の取得量をリセットする日にちを設定
        :param reset_day_of_month: 期間内の取得量をリセットする日にち
        :type reset_day_of_month: int
        """
        self.__reset_day_of_month = reset_day_of_month

    def get_reset_day_of_week(self):
        """
        期間内の取得量をリセットする曜日を取得
        :return: 期間内の取得量をリセットする曜日
        :rtype: unicode
        """
        return self.__reset_day_of_week

    def set_reset_day_of_week(self, reset_day_of_week):
        """
        期間内の取得量をリセットする曜日を設定
        :param reset_day_of_week: 期間内の取得量をリセットする曜日
        :type reset_day_of_week: unicode
        """
        self.__reset_day_of_week = reset_day_of_week

    def get_reset_hour(self):
        """
        期間内の取得量をリセットする時を取得
        :return: 期間内の取得量をリセットする時
        :rtype: int
        """
        return self.__reset_hour

    def set_reset_hour(self, reset_hour):
        """
        期間内の取得量をリセットする時を設定
        :param reset_hour: 期間内の取得量をリセットする時
        :type reset_hour: int
        """
        self.__reset_hour = reset_hour

    def get_latest_gain_max(self):
        """
        期間内の最大取得量を取得
        :return: 期間内の最大取得量
        :rtype: long
        """
        return self.__latest_gain_max

    def set_latest_gain_max(self, latest_gain_max):
        """
        期間内の最大取得量を設定
        :param latest_gain_max: 期間内の最大取得量
        :type latest_gain_max: long
        """
        self.__latest_gain_max = latest_gain_max

    def get_notification_url(self):
        """
        通知先 URLを取得
        :return: 通知先 URL
        :rtype: unicode
        """
        return self.__notification_url

    def set_notification_url(self, notification_url):
        """
        通知先 URLを設定
        :param notification_url: 通知先 URL
        :type notification_url: unicode
        """
        self.__notification_url = notification_url

    def get_create_wallet_trigger_script(self):
        """
        ウォレットの生成時 に実行されるGS2-Scriptを取得
        :return: ウォレットの生成時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__create_wallet_trigger_script

    def set_create_wallet_trigger_script(self, create_wallet_trigger_script):
        """
        ウォレットの生成時 に実行されるGS2-Scriptを設定
        :param create_wallet_trigger_script: ウォレットの生成時 に実行されるGS2-Script
        :type create_wallet_trigger_script: unicode
        """
        self.__create_wallet_trigger_script = create_wallet_trigger_script

    def get_create_wallet_done_trigger_script(self):
        """
        ウォレットの生成完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットの生成完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__create_wallet_done_trigger_script

    def set_create_wallet_done_trigger_script(self, create_wallet_done_trigger_script):
        """
        ウォレットの生成完了時 に実行されるGS2-Scriptを設定
        :param create_wallet_done_trigger_script: ウォレットの生成完了時 に実行されるGS2-Script
        :type create_wallet_done_trigger_script: unicode
        """
        self.__create_wallet_done_trigger_script = create_wallet_done_trigger_script

    def get_deposit_into_wallet_trigger_script(self):
        """
        ウォレットへの加算時 に実行されるGS2-Scriptを取得
        :return: ウォレットへの加算時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__deposit_into_wallet_trigger_script

    def set_deposit_into_wallet_trigger_script(self, deposit_into_wallet_trigger_script):
        """
        ウォレットへの加算時 に実行されるGS2-Scriptを設定
        :param deposit_into_wallet_trigger_script: ウォレットへの加算時 に実行されるGS2-Script
        :type deposit_into_wallet_trigger_script: unicode
        """
        self.__deposit_into_wallet_trigger_script = deposit_into_wallet_trigger_script

    def get_deposit_into_wallet_done_trigger_script(self):
        """
        ウォレットへの加算完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットへの加算完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__deposit_into_wallet_done_trigger_script

    def set_deposit_into_wallet_done_trigger_script(self, deposit_into_wallet_done_trigger_script):
        """
        ウォレットへの加算完了時 に実行されるGS2-Scriptを設定
        :param deposit_into_wallet_done_trigger_script: ウォレットへの加算完了時 に実行されるGS2-Script
        :type deposit_into_wallet_done_trigger_script: unicode
        """
        self.__deposit_into_wallet_done_trigger_script = deposit_into_wallet_done_trigger_script

    def get_withdraw_from_wallet_trigger_script(self):
        """
        ウォレットからの減算時 に実行されるGS2-Scriptを取得
        :return: ウォレットからの減算時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__withdraw_from_wallet_trigger_script

    def set_withdraw_from_wallet_trigger_script(self, withdraw_from_wallet_trigger_script):
        """
        ウォレットからの減算時 に実行されるGS2-Scriptを設定
        :param withdraw_from_wallet_trigger_script: ウォレットからの減算時 に実行されるGS2-Script
        :type withdraw_from_wallet_trigger_script: unicode
        """
        self.__withdraw_from_wallet_trigger_script = withdraw_from_wallet_trigger_script

    def get_withdraw_from_wallet_done_trigger_script(self):
        """
        ウォレットからの減算完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットからの減算完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__withdraw_from_wallet_done_trigger_script

    def set_withdraw_from_wallet_done_trigger_script(self, withdraw_from_wallet_done_trigger_script):
        """
        ウォレットからの減算完了時 に実行されるGS2-Scriptを設定
        :param withdraw_from_wallet_done_trigger_script: ウォレットからの減算完了時 に実行されるGS2-Script
        :type withdraw_from_wallet_done_trigger_script: unicode
        """
        self.__withdraw_from_wallet_done_trigger_script = withdraw_from_wallet_done_trigger_script

    def get_create_at(self):
        """
        作成日時(エポック秒)を取得
        :return: 作成日時(エポック秒)
        :rtype: int
        """
        return self.__create_at

    def set_create_at(self, create_at):
        """
        作成日時(エポック秒)を設定
        :param create_at: 作成日時(エポック秒)
        :type create_at: int
        """
        self.__create_at = create_at

    def get_update_at(self):
        """
        最終更新日時(エポック秒)を取得
        :return: 最終更新日時(エポック秒)
        :rtype: int
        """
        return self.__update_at

    def set_update_at(self, update_at):
        """
        最終更新日時(エポック秒)を設定
        :param update_at: 最終更新日時(エポック秒)
        :type update_at: int
        """
        self.__update_at = update_at

    def __getitem__(self, key):
        items = self.to_dict()
        if key in items.keys():
            return items[key]
        return super(Gold, self).__getitem__(key)

    def to_dict(self):
        return {
            "goldId": self.__gold_id,
            "ownerId": self.__owner_id,
            "name": self.__name,
            "description": self.__description,
            "serviceClass": self.__service_class,
            "balanceMax": self.__balance_max,
            "resetType": self.__reset_type,
            "resetDayOfMonth": self.__reset_day_of_month,
            "resetDayOfWeek": self.__reset_day_of_week,
            "resetHour": self.__reset_hour,
            "latestGainMax": self.__latest_gain_max,
            "notificationUrl": self.__notification_url,
            "createWalletTriggerScript": self.__create_wallet_trigger_script,
            "createWalletDoneTriggerScript": self.__create_wallet_done_trigger_script,
            "depositIntoWalletTriggerScript": self.__deposit_into_wallet_trigger_script,
            "depositIntoWalletDoneTriggerScript": self.__deposit_into_wallet_done_trigger_script,
            "withdrawFromWalletTriggerScript": self.__withdraw_from_wallet_trigger_script,
            "withdrawFromWalletDoneTriggerScript": self.__withdraw_from_wallet_done_trigger_script,
            "createAt": self.__create_at,
            "updateAt": self.__update_at,
        }
