# encoding: utf-8
#
# Copyright 2016 Game Server Services, Inc. or its affiliates. All Rights
# Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License.
# A copy of the License is located at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
# or in the "license" file accompanying this file. This file is distributed
# on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
# express or implied. See the License for the specific language governing
# permissions and limitations under the License.


class GoldPool(object):

    def __init__(self, params=None):
        if params is None:
            self.__gold_pool_id = None
            self.__owner_id = None
            self.__name = None
            self.__description = None
            self.__service_class = None
            self.__create_wallet_trigger_script = None
            self.__create_wallet_done_trigger_script = None
            self.__deposit_into_wallet_trigger_script = None
            self.__deposit_into_wallet_done_trigger_script = None
            self.__withdraw_from_wallet_trigger_script = None
            self.__withdraw_from_wallet_done_trigger_script = None
            self.__create_at = None
            self.__update_at = None
        else:
            self.set_gold_pool_id(params['goldPoolId'] if 'goldPoolId' in params.keys() else None)
            self.set_owner_id(params['ownerId'] if 'ownerId' in params.keys() else None)
            self.set_name(params['name'] if 'name' in params.keys() else None)
            self.set_description(params['description'] if 'description' in params.keys() else None)
            self.set_service_class(params['serviceClass'] if 'serviceClass' in params.keys() else None)
            self.set_create_wallet_trigger_script(params['createWalletTriggerScript'] if 'createWalletTriggerScript' in params.keys() else None)
            self.set_create_wallet_done_trigger_script(params['createWalletDoneTriggerScript'] if 'createWalletDoneTriggerScript' in params.keys() else None)
            self.set_deposit_into_wallet_trigger_script(params['depositIntoWalletTriggerScript'] if 'depositIntoWalletTriggerScript' in params.keys() else None)
            self.set_deposit_into_wallet_done_trigger_script(params['depositIntoWalletDoneTriggerScript'] if 'depositIntoWalletDoneTriggerScript' in params.keys() else None)
            self.set_withdraw_from_wallet_trigger_script(params['withdrawFromWalletTriggerScript'] if 'withdrawFromWalletTriggerScript' in params.keys() else None)
            self.set_withdraw_from_wallet_done_trigger_script(params['withdrawFromWalletDoneTriggerScript'] if 'withdrawFromWalletDoneTriggerScript' in params.keys() else None)
            self.set_create_at(params['createAt'] if 'createAt' in params.keys() else None)
            self.set_update_at(params['updateAt'] if 'updateAt' in params.keys() else None)

    def get_gold_pool_id(self):
        """
        ゴールドプールGRNを取得
        :return: ゴールドプールGRN
        :rtype: unicode
        """
        return self.__gold_pool_id

    def set_gold_pool_id(self, gold_pool_id):
        """
        ゴールドプールGRNを設定
        :param gold_pool_id: ゴールドプールGRN
        :type gold_pool_id: unicode
        """
        self.__gold_pool_id = gold_pool_id

    def get_owner_id(self):
        """
        オーナーIDを取得
        :return: オーナーID
        :rtype: unicode
        """
        return self.__owner_id

    def set_owner_id(self, owner_id):
        """
        オーナーIDを設定
        :param owner_id: オーナーID
        :type owner_id: unicode
        """
        self.__owner_id = owner_id

    def get_name(self):
        """
        ゴールドプール名を取得
        :return: ゴールドプール名
        :rtype: unicode
        """
        return self.__name

    def set_name(self, name):
        """
        ゴールドプール名を設定
        :param name: ゴールドプール名
        :type name: unicode
        """
        self.__name = name

    def get_description(self):
        """
        説明文を取得
        :return: 説明文
        :rtype: unicode
        """
        return self.__description

    def set_description(self, description):
        """
        説明文を設定
        :param description: 説明文
        :type description: unicode
        """
        self.__description = description

    def get_service_class(self):
        """
        サービスクラスを取得
        :return: サービスクラス
        :rtype: unicode
        """
        return self.__service_class

    def set_service_class(self, service_class):
        """
        サービスクラスを設定
        :param service_class: サービスクラス
        :type service_class: unicode
        """
        self.__service_class = service_class

    def get_create_wallet_trigger_script(self):
        """
        ウォレットの生成時 に実行されるGS2-Scriptを取得
        :return: ウォレットの生成時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__create_wallet_trigger_script

    def set_create_wallet_trigger_script(self, create_wallet_trigger_script):
        """
        ウォレットの生成時 に実行されるGS2-Scriptを設定
        :param create_wallet_trigger_script: ウォレットの生成時 に実行されるGS2-Script
        :type create_wallet_trigger_script: unicode
        """
        self.__create_wallet_trigger_script = create_wallet_trigger_script

    def get_create_wallet_done_trigger_script(self):
        """
        ウォレットの生成完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットの生成完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__create_wallet_done_trigger_script

    def set_create_wallet_done_trigger_script(self, create_wallet_done_trigger_script):
        """
        ウォレットの生成完了時 に実行されるGS2-Scriptを設定
        :param create_wallet_done_trigger_script: ウォレットの生成完了時 に実行されるGS2-Script
        :type create_wallet_done_trigger_script: unicode
        """
        self.__create_wallet_done_trigger_script = create_wallet_done_trigger_script

    def get_deposit_into_wallet_trigger_script(self):
        """
        ウォレットへの加算時 に実行されるGS2-Scriptを取得
        :return: ウォレットへの加算時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__deposit_into_wallet_trigger_script

    def set_deposit_into_wallet_trigger_script(self, deposit_into_wallet_trigger_script):
        """
        ウォレットへの加算時 に実行されるGS2-Scriptを設定
        :param deposit_into_wallet_trigger_script: ウォレットへの加算時 に実行されるGS2-Script
        :type deposit_into_wallet_trigger_script: unicode
        """
        self.__deposit_into_wallet_trigger_script = deposit_into_wallet_trigger_script

    def get_deposit_into_wallet_done_trigger_script(self):
        """
        ウォレットへの加算完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットへの加算完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__deposit_into_wallet_done_trigger_script

    def set_deposit_into_wallet_done_trigger_script(self, deposit_into_wallet_done_trigger_script):
        """
        ウォレットへの加算完了時 に実行されるGS2-Scriptを設定
        :param deposit_into_wallet_done_trigger_script: ウォレットへの加算完了時 に実行されるGS2-Script
        :type deposit_into_wallet_done_trigger_script: unicode
        """
        self.__deposit_into_wallet_done_trigger_script = deposit_into_wallet_done_trigger_script

    def get_withdraw_from_wallet_trigger_script(self):
        """
        ウォレットからの減算時 に実行されるGS2-Scriptを取得
        :return: ウォレットからの減算時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__withdraw_from_wallet_trigger_script

    def set_withdraw_from_wallet_trigger_script(self, withdraw_from_wallet_trigger_script):
        """
        ウォレットからの減算時 に実行されるGS2-Scriptを設定
        :param withdraw_from_wallet_trigger_script: ウォレットからの減算時 に実行されるGS2-Script
        :type withdraw_from_wallet_trigger_script: unicode
        """
        self.__withdraw_from_wallet_trigger_script = withdraw_from_wallet_trigger_script

    def get_withdraw_from_wallet_done_trigger_script(self):
        """
        ウォレットからの減算完了時 に実行されるGS2-Scriptを取得
        :return: ウォレットからの減算完了時 に実行されるGS2-Script
        :rtype: unicode
        """
        return self.__withdraw_from_wallet_done_trigger_script

    def set_withdraw_from_wallet_done_trigger_script(self, withdraw_from_wallet_done_trigger_script):
        """
        ウォレットからの減算完了時 に実行されるGS2-Scriptを設定
        :param withdraw_from_wallet_done_trigger_script: ウォレットからの減算完了時 に実行されるGS2-Script
        :type withdraw_from_wallet_done_trigger_script: unicode
        """
        self.__withdraw_from_wallet_done_trigger_script = withdraw_from_wallet_done_trigger_script

    def get_create_at(self):
        """
        作成日時(エポック秒)を取得
        :return: 作成日時(エポック秒)
        :rtype: int
        """
        return self.__create_at

    def set_create_at(self, create_at):
        """
        作成日時(エポック秒)を設定
        :param create_at: 作成日時(エポック秒)
        :type create_at: int
        """
        self.__create_at = create_at

    def get_update_at(self):
        """
        最終更新日時(エポック秒)を取得
        :return: 最終更新日時(エポック秒)
        :rtype: int
        """
        return self.__update_at

    def set_update_at(self, update_at):
        """
        最終更新日時(エポック秒)を設定
        :param update_at: 最終更新日時(エポック秒)
        :type update_at: int
        """
        self.__update_at = update_at

    def __getitem__(self, key):
        items = self.to_dict()
        if key in items.keys():
            return items[key]
        return super(GoldPool, self).__getitem__(key)

    def to_dict(self):
        return {
            "goldPoolId": self.__gold_pool_id,
            "ownerId": self.__owner_id,
            "name": self.__name,
            "description": self.__description,
            "serviceClass": self.__service_class,
            "createWalletTriggerScript": self.__create_wallet_trigger_script,
            "createWalletDoneTriggerScript": self.__create_wallet_done_trigger_script,
            "depositIntoWalletTriggerScript": self.__deposit_into_wallet_trigger_script,
            "depositIntoWalletDoneTriggerScript": self.__deposit_into_wallet_done_trigger_script,
            "withdrawFromWalletTriggerScript": self.__withdraw_from_wallet_trigger_script,
            "withdrawFromWalletDoneTriggerScript": self.__withdraw_from_wallet_done_trigger_script,
            "createAt": self.__create_at,
            "updateAt": self.__update_at,
        }
